/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { PolarLineSeriesBase } from "./PolarLineSeriesBase";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { Type, markType } from "igniteui-react-core/ES5/type";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
import { PolarLineSeriesBaseView } from "./PolarLineSeriesBaseView";
import { Path } from "igniteui-react-core/ES5/Path";
import { PathGeometry } from "igniteui-react-core/ES5/PathGeometry";
import { Extensions } from "igniteui-react-core/ES5/Extensions";
import { Numeric } from "igniteui-react-core/ES5/Numeric";
import { Color } from "igniteui-react-core/ES5/Color";
/**
 * @hidden
 */
var PolarSplineAreaSeries = /** @class */ (function (_super) {
    tslib_1.__extends(PolarSplineAreaSeries, _super);
    function PolarSplineAreaSeries() {
        var _this = _super.call(this) || this;
        _this.ab = PolarSplineAreaSeries.$;
        return _this;
    }
    PolarSplineAreaSeries.prototype.bf = function () {
        return new PolarSplineAreaSeriesView(this);
    };
    PolarSplineAreaSeries.prototype.im = function (a) {
        _super.prototype.im.call(this, a);
        this.o6 = a;
    };
    PolarSplineAreaSeries.prototype.o4 = function (a) {
        var b = a;
        b.c0();
    };
    PolarSplineAreaSeries.prototype.o5 = function (a, b) {
        this.o4(b);
        if (a.m.count < 1) {
            return;
        }
        var c = b;
        c.c3._opacity = this.d3;
        c.c1(a.m, this.o7);
    };
    PolarSplineAreaSeries.prototype.get_o1 = function () {
        return true;
    };
    PolarSplineAreaSeries.prototype.is = function (a, b, c, d) {
        _super.prototype.is.call(this, a, b, c, d);
        switch (b) {
            case PolarSplineAreaSeries.$$p[0]:
                this.i6(false);
                break;
        }
    };
    PolarSplineAreaSeries.$t = markType(PolarSplineAreaSeries, 'PolarSplineAreaSeries', PolarLineSeriesBase.$);
    return PolarSplineAreaSeries;
}(PolarLineSeriesBase));
export { PolarSplineAreaSeries };
Type.dep(DependencyProperty, PropertyMetadata, PolarSplineAreaSeries, 'raisePropertyChanged', ['Stiffness:o7:o9', [1, 0.5]]);
/**
 * @hidden
 */
var PolarSplineAreaSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(PolarSplineAreaSeriesView, _super);
    function PolarSplineAreaSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cz = null;
        _this.c4 = ((function () {
            var $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        _this.c2 = ((function () {
            var $ret = new Path();
            $ret.aj = new PathGeometry();
            return $ret;
        })());
        _this.cz = a;
        return _this;
    }
    PolarSplineAreaSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.bj = 1;
        }
    };
    Object.defineProperty(PolarSplineAreaSeriesView.prototype, "c3", {
        get: function () {
            return this.c2;
        },
        enumerable: true,
        configurable: true
    });
    PolarSplineAreaSeriesView.prototype.c0 = function () {
        Extensions.e(this.c2.aj);
        Extensions.e(this.c4.aj);
        this.an();
    };
    PolarSplineAreaSeriesView.prototype.c1 = function (a, b) {
        this.c4.aj.b = Numeric.h(a.count + 1, function (c) { return c < a.count ? a._inner[c].x : a._inner[c - a.count].x; }, function (c) { return c < a.count ? a._inner[c].y : a._inner[c - a.count].y; }, b);
        this.c2.aj.b = Numeric.h(a.count + 1, function (c) { return c < a.count ? a._inner[c].x : a._inner[c - a.count].x; }, function (c) { return c < a.count ? a._inner[c].y : a._inner[c - a.count].y; }, b);
        this.an();
    };
    PolarSplineAreaSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
        this.c2._fill = this.e.kw;
        this.c2._opacity = this.e.d3;
        this.c4._stroke = this.e.kx;
        this.c4.ac = this.e.ev;
        this.c4.ai = this.e.k4;
        this.c4.ad = this.e.k5;
    };
    PolarSplineAreaSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        var a = this.bl();
        this.c2._fill = a;
        this.c2._opacity = 1;
        this.c4._stroke = a;
        this.c4.ac = this.e.ev + 3;
    };
    PolarSplineAreaSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            a.s(this.c2);
            a.s(this.c4);
        }
    };
    PolarSplineAreaSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.c4, "polarShape", ["Main"]);
        this.e.a2.exportPathData(a, this.c2, "fillShape", ["Fill"]);
    };
    PolarSplineAreaSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.k3 = a;
        this.e.es = 5;
        this.e.et = 5;
        this.e.eu = 5;
    };
    PolarSplineAreaSeriesView.$t = markType(PolarSplineAreaSeriesView, 'PolarSplineAreaSeriesView', PolarLineSeriesBaseView.$);
    return PolarSplineAreaSeriesView;
}(PolarLineSeriesBaseView));
export { PolarSplineAreaSeriesView };
